require 'json'
require 'securerandom'
require 'timeout'
require 'bunny'
require 'active_support'

require 'mafia/logger'
require 'mafia/dealer'
require 'mafia/consumer'
require 'mafia/consumer_pool'
require 'mafia/default_consumer'

module Mafia
  def self.register_consumer(consumer)
    self.consumers << consumer
  end

  def self.consumers
    @consumers ||= []
  end

  def self.configure(c={})
    @config = config.merge(c)
  end

  def self.config
    @config ||= {}
  end

  def self.logger
    Mafia::Logger.logger
  end

  def self.log_level
    @config[:log_level] || ::Logger::INFO
  end

  def self.config_to_url(config)
    user = config[:username]
    password = config[:password]
    host = config[:host]
    port = config[:port]
    vhost = config[:vhost]
    "amqp://#{user}:#{password}@#{host}:#{port}#{vhost}"
  end
end
