module Mafia
  module Consumer
    def initialize(routing_key=nil)
      @routing_key = routing_key
    end

    def self.included(base)
      base.extend(ClassMethods)
      Mafia.register_consumer(base)
    end

    module ClassMethods
      attr_reader :routing_key

      def consume(routing_key)
        @routing_key = routing_key
      end

      def process(routing_key, *args)
        new(routing_key).process(*args)
      end

      # Explicitly set the queue name
      def queue_name(name)
        @queue_name = name
      end

      def get_queue_name
        return @queue_name unless @queue_name.nil?
        queue_name = self.name.gsub(/::/, ':')
        queue_name.gsub!(/([^A-Z:])([A-Z])/) { "#{$1}_#{$2}" }
        queue_name.downcase
      end
    end
  end
end
