module Mafia
  module Logger
    class MafiaFormatter < ::Logger::Formatter
      def call(severity, time, program_name, message)
        "#{time.utc.iso8601} #{Process.pid} #{severity} -- #{message}\n"
      end
    end

    def self.setup_logger(target = $stdout)
      @logger = ::Logger.new(target)
      @logger.level = Mafia.log_level
      @logger.formatter = MafiaFormatter.new
      @logger
    end

    def self.logger
      @logger || setup_logger
    end

    def self.logger=(logger)
      @logger = logger
    end

    def logger
      Mafia::Logger.logger
    end
  end
end
